Klappen2 = {};

function Klappen2.prerequisitesPresent(specializations)
    return true;
end;

function Klappen2:load(xmlFile)

self.setRotateDirection2= SpecializationUtil.callSpecializationsFunction("setRotateDirection2");  -- setRotation wäre hier irreführend weils die funktion von Giants schon gibt, nimm lieder die hier. Mit dem aufruf registrierst du die funktion.

local rotationPartNodeRotation2= Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rotation2#index"));
    if rotationPartNodeRotation2 ~= nil then
        self.Rotation2 = {};
        self.Rotation2.node = rotationPartNodeRotation2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rotation2#minRot"));
        self.Rotation2.minRot = {};
        self.Rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rotation2#maxRot"));
        self.Rotation2.maxRot = {};
        self.Rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rotation2#rotTime"), 2)*1000;
    end;

  self.currentRotationDir2= false; -- die aktuelle richtung der drehung als Boolean(wahrheitswert)
end;

function Klappen2:delete()
end;

function Klappen2:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Klappen2:keyEvent(unicode, sym, modifier, isDown)
       if isDown and sym == Input.KEY_KP_5 then
             self:setRotateDirection2(not self.currentRotationDir2); -- tastenevents sollte man als funktion auslagern, um MP-sachen zu vereinfachen. Beim tastendruck wird eben die funktion aufgerufen nur eben mit dem genau anderen wert :D
      end;
      end;
function Klappen2:readStream(streamId, connection)  -- wird Aufgerufen wenn ich selber ein Spiel join
     self:setRotateDirection2(streamReadBool(streamId), true);  -- ich rufe also vom server die aktuelle richtung ab. True ist hier wichtig, weil ich will ja nur an meinem rechner den wert haben, und nich an alle anderen Mitspiele das Event schicken (weil die haben den aktuellen wert ja schon :-)) Das true hier also nie vergessen
end;

function Klappen2:writeStream(streamId, connection)  -- wird am Server aufgerufen wenn ein Spieler joint
    streamWriteBool(streamId, self.currentRotationDir2);   -- Wenn einspieler joint möchte ich ihm die aktuelle rotationsrichtung übertragen
end;

function Klappen2:update(dt)
end;


function Klappen2:updateTick(dt)  -- ist wie Update nur verzögert um performance zu sparen. Prinzipiell sollte alles hier rein, bis auf sachen für die die verzögerung nicht reihct(z.b. tastendruck etz)
	if self.Rotation2 ~= nil then
		local x, y, z = getRotation(self.Rotation2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Rotation2.maxRot, self.Rotation2.minRot, 3, self.Rotation2.rotTime, dt, not self.currentRotationDir2); -- hier habe ich nur drehen druch currentRotationDir2 ersetzt
		setRotation(self.Rotation2.node, unpack(newRot));
   end;
end;

function Klappen2:setRotateDirection2(newDirection, noEventSend)  -- noEventSend bedeutet , dass wenn die variable den wert true hat kein event an andere mitspieler gesendet werden soll
    RotationEvent2.sendEvent(self, newDirection, noEventSend);	-- wir versuchen das event zu senden. Als parameter übergeben wir die neue rotationDirection, die wir beim tastendruck setzen
    self.currentRotationDir2 = newDirection; -- wir setzen nun lokal die neue Richtung
end;
function Klappen2:draw()
end; 
